import perenono.util.zip.decompress.*;
import perenono.util.zip.compress.*;
import java.io.*;

/**
* this class alw to use the compression lib
* @author <a href="mailto:noel.perez@pere-nono.com">Perez Nol</a><br> web site:<a href="http://www.pere-nono.com">http://www.pere-nono.com</a>
* @version 0.5a
* @see this application is distributed under GPL licence
*/
public class Noyau
{

/**
* this function decompress the _archive data
* @author <a href="mailto:noel.perez@pere-nono.com">Perez Nol</a><br> web site:<a href="http://www.pere-nono.com">http://www.pere-nono.com</a>
* @version 0.5a
* @see this application is distributed under GPL licence
*/
public void decompress(File _archive, File[] _output)
{
boolean gzip = false;

String nameMin = (_archive.getName()).toLowerCase();
if(nameMin.endsWith(".gz")) gzip=true;
else if(nameMin.endsWith(".tgz"))
	{
	if(Jzipper.DEBUG) System.out.println("Warning: this application can't manage tar file, this just uncompress");
	gzip=true;
	return;
	}

try{
if(_output!=null && _output.length>0)
	{
	if(!gzip && (!_output[0].exists() || _output[0].isDirectory()))
		{
		ZipDecompress.decompress(_archive,_output[0]);
		}
	else if(gzip)
		{
		GZipDecompress.decompress(_archive,_output[0]);
		}
	}
else if(gzip)
	{
	File temp = GZipDecompress.decompress(_archive);
	}
else if(!gzip)
	{
	ZipDecompress.decompress(_archive);
	}
else	{
	if(Jzipper.DEBUG) System.out.println("you must give an output directory or file");
	}
}catch(Exception ex)
	{
	System.out.println("file error\n");
	if(Jzipper.DEBUG) ex.printStackTrace();
	}
}


/**
* this function compress the data into _archvie
* @author <a href="mailto:noel.perez@pere-nono.com">Perez Nol</a><br> web site:<a href="http://www.pere-nono.com">http://www.pere-nono.com</a>
* @version 0.5a
* @see this application is distributed under GPL licence
*/
public void compress(File _archive, File[] _output)
{
boolean gzip = false;

String nameMin = (_archive.getName()).toLowerCase();
if(nameMin.endsWith(".gz")) gzip=true;
else if(nameMin.endsWith(".tgz"))
	{
	if(Jzipper.DEBUG) System.out.println("Warning: this application can't manage tar file, this just uncompress");
	gzip=true;
	return;
	}

try{
if(_output!=null && _output.length>0)
	{
	if(!gzip)
		{
		ZipCompress.compress(_archive,_output);
		}
	else if(gzip)
		{
		GZipCompress.compress(_archive,_output[0]);
		}
	}
else if(gzip)
	{
//	File temp = GZipCompress.compress(_archive);
	}
else if(!gzip)
	{
//	ZipCompress.compress(_archive);
	}
else	{
	if(Jzipper.DEBUG) System.out.println("you must give an output directory or file");
	}
}catch(Exception ex)
	{
	System.out.println("file error\n");
	if(Jzipper.DEBUG) ex.printStackTrace();
	}

}

}